<?php
session_start();
//Hexa -> RGB átalakító
function html2rgb($color)
{
  if ($color[0] == "#")
    $color = substr($color, 1);
  if (strlen($color) == 6)
    list($r, $g, $b) = array($color[0].$color[1],
                             $color[2].$color[3],
                             $color[4].$color[5]);
  elseif (strlen($color) == 3)
    list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
  else
    return false;
  $r = hexdec($r); $g = hexdec($g); $b = hexdec($b);
  return array($r, $g, $b);
}
//behúzó-jel karakter cseréje behúzó szóközökre
function charswapping($in_line, $indent)
{ return preg_replace("/\#/", $indent, $in_line); }

//AKTUÁLIS "SESSION-VÁLTOZÓK" LEKÉRDEZÉSE 
  //$font_tipe = isset($_GET["tipus"]) ? intval($_GET["tipus"]) : 0;
$font_tipe = isset($_SESSION['ujkep']['tipus']) ? intval($_SESSION['ujkep']['tipus']) : 0;
  //$font_func_path = "";
$font_func_path = isset($_SESSION['ujkep']['fontpat']) ? $_SESSION['ujkep']['fontpat'] : "";
  //$text = " Egy próba a szöveg PNG-fájlba írására  ";
$text = isset($_SESSION['ujkep']['szoveg']) ? $_SESSION['ujkep']['szoveg'] : " Egy szöveg PNG-fájlba ";
  //$fszin = "#C7001B";
$fszin = isset($_SESSION['ujkep']['fszin']) ? $_SESSION['ujkep']['fszin'] : "#C7001B";
  //$aszin = "#FF979C";
$aszin = isset($_SESSION['ujkep']['aszin']) ? $_SESSION['ujkep']['aszin'] : "#FF979C";
  //$line_number = 0;
$line_number = isset($_SESSION['ujkep']['sorok_szama']) ? intval($_SESSION['ujkep']['sorok_szama']) : 0;
  //$indent_num = 0;
$indent_num = isset($_SESSION['ujkep']['behuzas']) ? intval($_SESSION['ujkep']['behuzas']) : 0;
  //$fsize = 24;
$fsize = isset($_SESSION['ujkep']['font_meret']) ? intval($_SESSION['ujkep']['font_meret']) : 24;
  //$font_count = 80;
$font_count = isset($_SESSION['ujkep']['font_szam']) ? intval($_SESSION['ujkep']['font_szam']) : 80;
  //$Justify = "2";
$Justify = isset($_SESSION['ujkep']['igazit_hor']) ? $_SESSION['ujkep']['igazit_hor'] : "2";
  //$lead = 24; //betűtípustól függő, általában a $font_meret fele
$lead = isset($_SESSION['ujkep']['sor_koz']) ? intval($_SESSION['ujkep']['sor_koz']) : 24;
  //$Hoffs = 0; //betűtípustól függő
$Hoffs = isset($_SESSION['ujkep']['kep_magas_kor']) ? intval($_SESSION['ujkep']['kep_magas_kor']) : 0;
  //$angle = 0;
$angle = isset($_SESSION['ujkep']['sor_doles']) ? intval($_SESSION['ujkep']['sor_doles']) : 0;
  //$farnyek =  1; //0 => nincs, 1 => van
$farnyek = isset($_SESSION['ujkep']['farnyek']) ? intval($_SESSION['ujkep']['farnyek']) : 1;
  //$W = 0; //ha nincs megadva automatikus
$W = isset($_SESSION['ujkep']['kep_szeles']) ? intval($_SESSION['ujkep']['kep_szeles']) : 0;
  //$H = 0; //ha nincs megadva automatikus
$H = isset($_SESSION['ujkep']['kep_magas']) ? intval($_SESSION['ujkep']['kep_magas']) : 0;

//ADOTT VÁLTOZÓK MÓDOSÍTÁSA a "$line_number" FÜGGVÉNYÉBEN
if ($line_number>1)
{ $angle = 0; }
if ($line_number<2)
{ $Hoffs = 0;
  $font_count = 80;
  $indent_num = 0;
}
//ADOTT VÁLTOZÓK TIPUSÁNAK MÓDOSÍTÁSA
//árnyék létrehozás van/nincs
if ($farnyek==1)
{ $shadow = true; }
else
{ $shadow = false; }
//szín kódok konvertálása
$color = html2rgb($fszin);
$shcolor = html2rgb($aszin);

//ÁLLANDÓ BEÁLLÍTÁSI PARAMÉTEREK:
//font-fájlok sorszám alapján
$font_fajlok = array("fonts/arial.ttf",
                     "fonts/Century.ttf",
                     "fonts/FLbrsa1.ttf",
                     "fonts/Isabella.ttf",
                     "fonts/gunplay3.ttf"
                     );
$fontszam = count($font_fajlok);
if ($font_tipe > $fontszam-1)
  $font_tipe = 0;
//kiválasztott font-fájl 
$font = '/'.$font_func_path.$font_fajlok[$font_tipe]; 
//BEGIN ha nincs a választott font
if (file_exists(getcwd().$font))
{ $font = $font; }
else
{ $font = '/'.$font_func_path.'/fonts/arial.ttf'; }
//END ha nincs a választott font

//A KÉP-ERŐFORRÁST LÉTREHOZÓ FÜGGVÉNY
function create_png_resource_text($text, $line_number, $font, $font_count, $Justify=2, $lead,
                             $W, $H, $Hoffs,
                             $fsize=12, $angle, $color=array(0x00,0x00,0x00), $shcolor=array(0xFF,0xFF,0xFF),
                             $shadow=false, $indent_num)
{
  //BEGIN behúzó szóköz beállítás
  $indent_count = array(""," ","  ","   ","    ","     ");
  $indent_num = ($indent_num>5)?5:($indent_num<0?1:$indent_num);
  $indent = $indent_count[$indent_num];
  //behúzó-jel karakter cseréje behúzó szóközökre
  $text = charswapping($text,$indent);
  //END  behúzó szóköz beállítás
  //BEGIN font-szám minimum beállítása
  if (($font_count < 1) or ($font_count >80))
  { $font_count = 50; }
  else
  { $font_count = $font_count; }
  //END font-szám minimum beállítása
  //Vízszintes igazítás
  $L_R_C = $Justify;
  //Teljes szöveg befoglaló téglalap kalkuláció
  $_bx = imageTTFBbox($fsize,0,getcwd().$font,$text); 
  //BEGIN sorok számának megállapítása
  $s = preg_split('/[\n\r]+/',$text);  //tömb a soroknak
  $nL = count($s);  //sorok száma
  //END sorok számának megállapítása
  //Sorköz minimum beállítása
  $lead = ($lead<0)?0:$lead; //sorköz nem lehet kisebb 0-nél
  //TruType betűtípusú  1-soros minta-szöveg magasságának lekérdezése(font-függő)
  //BEGIN egy-soros minta-szöveg befoglaló téglalap kalkuláció
  $abc ="ÁRVÍZTŰRŐ árvíztűrő GÁT gát ";       
  $font_minta = imageTTFBbox($fsize,0,getcwd().$font,$abc);
  $font_W=abs($font_minta[2]-$font_minta[0]);
  $font_H=abs($font_minta[5]-$font_minta[3]);
  //END egy-soros minta-szöveg befoglaló téglalap kalkuláció
  //BEGIN dölésszög korlátok beállítása
  if (($angle < -90) or ($angle > 90))
  { $angle = 0; }
  else
  { $angle = $angle; }
  //END dölésszög korlátok beállítása
  //BEGIN képszélesség/képmagasság  (ha beállított akkor az, ha nem akkor kalkulált lesz)
  $W = ($W===0)?abs($_bx[2]-$_bx[0]):$W; //jobb alsó - bal alsó sarok X koordináta
  $H = ($H===0)?abs($_bx[5]-$_bx[3]):$H; //jobb felső - jobb alsó sarok Y koordináta
  //sorok számától függő méretek számitása font-magasság, dölés, magasság-korrigálás alapján
  if ($line_number>1) //több soros
  { $H = $nL * ($font_H+$lead)-$Hoffs;
  }
  else                //egy soros(dönthető)
  { $a1 = sin(deg2rad(abs($angle))) * $W;
    $b1 = cos(deg2rad(abs($angle))) * $H;
    $a2 = sin(deg2rad(abs($angle))) * $H;
    $b2 = cos(deg2rad(abs($angle))) * $W;
    $W = intval($a2+$b2);
    $H =  intval($a1+$b1+($nL * $lead)-(sin(deg2rad(abs($angle))) * $Hoffs) );
  }
  //END képszélesség/képmagasság
  //MEGJELENÍTETT KÉPSZÉLESSÉG KORLÁT
  $W = ($W > 800)?800:$W;
  //BEGIN KÉP LÉTREHOZÁSA global $im;
  // Set the content-type
  header('Content-Type: image/png');
  $im = @imagecreate($W, $H) or die("Nem lehet inicializálni új GD kép folyamatot!");
  $text_color = imagecolorallocate($im, $color[0], $color[1], $color[2]); 
  $shadow_color = imagecolorallocate($im, $shcolor[0], $shcolor[1], $shcolor[2]); 
  $atlatszo = imagecolorallocatealpha($im, $color[0], $color[1], $color[2], 127);
  imagefilledrectangle($im, 0, 0, $W, $H, $atlatszo);
  //font-kép létrehozás különböző igazítással
  if($L_R_C == 0)
  { //Igazítás balra
    $uj_Y=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,  0,  getcwd().$font,   $val);
      //string koordináta meghatározása
      if ($line_number>1) //több soros esetén 
      { //X koordináta
        $_X = $W-$W;
        //Y koordináta
        $_H = abs($_b[5]-$_b[3]);
      }
      else                //egysoros (dönthető) esetén 
      {
        if ($angle<0)          //negatív dölésszög
        { //X koordináta
          $_X = intval($W-$W+(sin(deg2rad(abs($angle))) * $lead));
          //Y koordináta
          $_H = intval($b1); 
        }
        else                   //0 és pozitív dölésszög
        { //X koordináta
          $_X = intval($W-$W+(sin(deg2rad(abs($angle))) * 2 * $lead));
          //Y koordináta
          $_H = intval($b1+$a1);
        }
      }
      $uj_Y += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_Y, $text_color, getcwd().$font, $val);
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_Y+1, $shadow_color, getcwd().$font, $val); }      
      $uj_Y += $lead;
    }
  }elseif ($L_R_C == 1)
  { //Igazítás jobbra
    $uj_H=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,  0,  getcwd().$font,   $val);
      $_W = abs($_b[2]-$_b[0]);
      //X koordináta
      $_X = $W-$_W;
      //Y koordináta
      $_H = abs($_b[5]-$_b[3]); 
      $uj_H += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_H, $text_color, getcwd().$font, $val);   
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_H+1, $shadow_color, getcwd().$font, $val); }      
      $uj_H += $lead;
    }
  }elseif($L_R_C == 2)
  { //Igazítás középre
    $uj_H=0;
    foreach($s as $key=>$val)
    { $_b = imageTTFBbox($fsize,0,getcwd().$font,$val);
      $_W = abs($_b[2]-$_b[0]);
      //X koordináta
      $_X = abs($W/2)-abs($_W/2);
      //Y koordináta
      $_H = abs($_b[5]-$_b[3]); 
      $uj_H += $_H;             
      imageTTFText($im, $fsize, $angle, $_X, $uj_H, $text_color, getcwd().$font, $val);   
      if ($shadow)
      { imageTTFText($im, $fsize, $angle, $_X+1, $uj_H+1, $shadow_color, getcwd().$font, $val); }      
      $uj_H += $lead;
    }
  }
  imagepng($im);
  imagedestroy($im);
  //END KÉP LÉTREHOZÁSA       
}

//A KÉP-ERŐFORRÁS LÉTREHOZÁSA
create_png_resource_text($text, $line_number, $font, $font_count, $Justify, $lead, $W, $H, $Hoffs, $fsize, $angle, $color, $shcolor, $shadow, $indent_num);
?>
